#!/bin/bash

mkdir obj

cd ovl
for FL in ovl*.asm; do
	sjasmplus "${FL}" || exit 1
done
cd ..

echo -e ";VQ3 overlays sizes\n" > ovltab.asm

for NUM in `seq 0 7`; do
	mhmt -zxh -hst "obj/ovl${NUM}.bin" "obj/ovl${NUM}.hr1"
	SIZE=`stat -c %s "obj/ovl${NUM}.hr1"`	# SIZE = packed file size
	CSZ=$((${SIZE}/256))			# CSZ = SIZE/256 + ((SIZE & 0xFF) ? 1 : 0) : size in sectors
	if [ $((${SIZE} & 255)) -gt 0 ]; then
		CSZ=$((${CSZ} + 1))
	fi
	echo -e "\tdb ${CSZ}" >> ovltab.asm
done

sjasmplus main.asm || exit 1

mhmt -zxh -hst "obj/page0.db00.bin" "obj/page0.db00.hr1"
mhmt -zxh -hst "VQ3a-map.bin" "obj/page1.9c00.hr1"
mhmt -zxh -hst "obj/page3.bin" "obj/page3.hr1"
mhmt -zxh -hst "obj/page4.bin" "obj/page4.hr1"
mhmt -zxh -hst "obj/page6.bin" "obj/page6.hr1"
mhmt -zxh -hst "obj/main.7171.7177.bin" "obj/main.7171.7177.hr1"

sjasmplus loader.asm || exit 1

IMG="VQ3.scl"
mctrd cscl ${IMG}
mctrd add "obj/boot.bas" ${IMG} -b -a 1
mctrd add "dehr1.6000.bin" ${IMG}
mctrd add "obj/page6.hr1" ${IMG}
mctrd add "obj/page4.hr1" ${IMG}
mctrd add "obj/page3.hr1" ${IMG}
mctrd add "obj/page1.9c00.hr1" ${IMG}
mctrd add "obj/page0.db00.hr1" ${IMG}
mctrd add "skin.hst" ${IMG}
mctrd add "obj/main.7171.7177.hr1" ${IMG}
for NUM in `seq 0 7`; do
	mctrd add "obj/ovl${NUM}.hr1" ${IMG}
done

rm -r obj