﻿; VQ3

	DEVICE ZXSPECTRUM128

NEP_nr  EQU 96

GfxPage EQU 0
MapPage EQU 1
AniPage EQU 3
MuzPage EQU 4
ActPage EQU 6
WrkPage EQU 7

TestDOS EQU 8345
Out_DOS EQU 10835
WaitDOS EQU 16117
SaveDOS EQU 16330
LoadDOS EQU 16357

Map     EQU #6000
MapMask EQU #6800

        MACRO DBW bt,wr
        DB bt
        DW wr
        ENDM 

        MACRO LDB dst,src
        LD A,src
        LD dst,A
        ENDM
        
	MACRO DEFBLOCK num,arr
	 DUP num
	 DB arr
	 EDUP
	ENDM

Sprt_P  EQU #9C00
Sprt_M  EQU #A400
Sprt_N  EQU #AC00

	ORG 0xC000,MuzPage
	INCLUDE "pt3xplayer.asm"
muzadrs	dw 0,muz1,muz2,muz3,muzfgt,muzgo,finmuz
muz1	incbin "muz/ingame1.pt3"
muz2	incbin "muz/ingame2.pt3"
muz3	incbin "muz/ingame3.pt3"
muzfgt	incbin "muz/inbattle.pt3"
muzgo	incbin "muz/gameover.pt3"
finmuz	incbin "muz/finalmuz.pt3"

	display "muz.ovl\t(#C000,",MuzPage,"),",$-0xc000
	savebin "obj/page4.bin",0xc000,$-0xc000

        ORG #9C00,MapPage
        INCBIN "VQ3a-map.bin"

        ORG #6200,WrkPage
skin	incbin "skin.hst"

        ORG #7171,WrkPage

aBgn	JP intupt		; 7171
START   LD HL,#0100		; 7174 WARNING: HL = next TRK/SEC = overlays begin
        JP start		; 7177
FINDITM JP finditm
ERROR   JP error
TEXT    JP text
SETANIM JP setanim
DELITEM JP delitem
GETITEM JP getitem
TESTBIT JP testbit
SETBIT  JP setbit
SETAMAP JP setamap
CHNGMAP JP chanmap
WEND    JP wend
IFITEM  JP ifitem
SEE_EXT JP see_ext
LOAD_PG JP load_PG
FREEITM JP freeitm
GO_OVL  JP go_ovl
SET_MUZ JP setmuz
MUZ_OFF JP muzoff
darker  JP DARKER

intupt  PUSH AF,BC,DE,HL
        EXX 
        EXA 
        PUSH AF,BC,DE,HL,IX,IY

        LD A,(CurPage)
        PUSH AF

aniflag SCF 
        CALL NC,ANIMATE
fani_F  SCF 
        CALL NC,FANI_NG

        CALL MUZBANK
muzflag SCF 
        CALL NC,#C005

        POP AF
        CALL BANK

        POP IY,IX,HL,DE,BC,AF
        EXX 
        EXA 
        POP HL,DE,BC,AF
        EI 
skip    RET 

muzoff  LD A,(CurPage)
        PUSH AF
        CALL MUZBANK
        LD A,#37
        LD (muzflag),A
        PUSH BC
        PUSH DE
        PUSH HL
        CALL #C008
        POP HL
        POP DE
        POP BC
        POP AF
        JP BANK

setmuz  PUSH IX
	PUSH AF
        LD (CurMuz+1),A
        CALL MUZ_OFF
        POP BC
        LD A,(CurPage)
        PUSH AF
        CALL MUZBANK
        LD HL,muzadrs
        LD C,B
        LD B,0
        ADD HL,BC
        ADD HL,BC
        LD A,(HL)
        INC HL
        LD H,(HL)
        LD L,A			; HL:muzadr
/*
        PUSH HL
        LD DE,99
        ADD HL,DE
        LD A,(HL)
        ADD A,#CC
        LD H,A
        LD L,0
        LD DE,#C200
        LD BC,192
        LDIR 
        POP HL
*/
        CALL #C003
        EI 
        POP AF
        CALL BANK
        POP IX
MUZ_ON  LD A,#A7
        LD (muzflag),A
        RET 

ANI_ON  LD A,#A7
        JR aonf
ANI_OFF LD A,#37
aonf    LD (aniflag),A
        RET 

FAN_ON  LD A,#A7
        JR fonf
FAN_OFF LD A,#37
fonf    LD (fani_F),A
        RET 

MUZBANK PUSH AF
        LD A,MuzPage
        JR abank
GFXBANK PUSH AF
        LD A,GfxPage
        JR abank
WRKPAGE PUSH AF
        LD A,WrkPage
        JR abank
ACTBANK PUSH AF
        LD A,ActPage
        JR abank
ANIBANK PUSH AF
        LD A,AniPage
        JR abank
MAPBANK PUSH AF
        LD A,MapPage
abank   CALL BANK
        POP AF
        RET 
BANK    PUSH BC
        LD (CurPage),A
        AND 7
        OR #10
        LD BC,#7FFD
        OUT (C),A
        POP BC
        RET 

CurPage DB 0

start   DI 
        CALL ACTBANK
        LD (ovl_TRS),HL
        LD A,(23798)
        CALL DRIVE
        LD (GAMOVER+1),SP
        CALL GFXBANK
        LD HL,skin
        LD DE,#C000
        CALL HRUST
restart CALL MUZ_OFF

        LD A,1
        CALL SET_MUZ

        LD HL,#7000
        LD DE,#7001
        LD BC,#100
        LD A,H
        LD I,A
        INC A
        LD (HL),A
        LDIR 
        IM 2
        CALL ANI_OFF
        CALL FAN_OFF
        CALL MUZ_ON
        EI 
        LD HL,#5800
        LD DE,#5801
        LD BC,767
        LD (HL),L
        LDIR 
        XOR A
        OUT (254),A
        CALL GFXBANK
        LD HL,#C000
        LD DE,#4000
        LD BC,#1800
        LDIR 
        HALT 
        LD BC,768
        LDIR 
        CALL WRKPAGE

        LD HL,dwn_ico
        LD DE,#4033
        LD B,1
        CALL SPRITE
        CALL ANIBANK
        LD B,0
        CALL FIND_B
        PUSH IX
        CALL INIT
        POP IX
        CALL ANIBANK
        LD A,(IX+6)
        LD (CurMap),A
        LD HL,Bits
        LD DE,Bits+1
        LD BC,31
        LD (HL),0
        LDIR 
        LD HL,#FFFF
        LD (Items),HL
        LD (Items+1),HL
        LD HL,0
        LD (Money),HL
        CALL OUT_EFS
        CALL DRAWMAP
        CALL ANI_ON
        CALL DRITEMS
        CALL ITMRAMK
        CALL PRN_MON

test_1  LD A,#FE
        IN A,(254)
        RRA 
        JR C,test_NS
        LD A,#7F
        IN A,(254)
        RRA 
        RRA 
        JR C,test_NS
        LD A,#FB
        IN A,(254)
        AND 16
        JP Z,GAMOVER
        LD A,#FB
        IN A,(254)
        AND 8
        JP Z,ENDING
test_NS LD HL,Port_A
        CALL KEYS
        LD C,A
        LD HL,KeyTab
test_2  LD A,(HL)
        AND A
        JR Z,test_1
        INC HL
        CP C
        JR Z,test_3
        INC HL
        INC HL
        JR test_2
test_3  LD A,(HL)
        INC HL
        LD H,(HL)
        LD L,A
        CALL CALL_HL
        JR test_1

KeyTab  DBW "Q",KEY_UP
        DBW "A",KEY_DN
        DBW "O",KEY_LF
        DBW "P",KEY_RG
        DBW " ",KEY_FR
        DBW "1",HOT_K
        DBW "2",HOT_K
        DBW "3",HOT_K
        DBW "4",HOT_K
        DBW "Z",ICRS_LF
        DBW "X",ICRS_RG
        DB 0

Port_A  DB #FB,1,"Q",#FD,1,"A",#DF,2,"O",#DF,1,"P",#7F,1," "
        DB #EF,8,"Q",#EF,16,"A",#F7,16,"O",#EF,4,"P",#EF,1," "
        DB #BF,1,13
        DB #F7,1,"1",#F7,2,"2",#F7,4,"3",#F7,8,"4"
        DB #FE,2,"Z",#FE,4,"X",0

KEY_DN  LD D,0
        LD BC,#0304
        JR key_DIR
KEY_UP  LD D,1
        LD BC,#0205
        JR key_DIR
KEY_LF  LD D,2
        LD BC,#0006
        JR key_DIR
KEY_RG  LD D,3
        LD BC,#0107
key_DIR CALL ANIBANK
        LD A,(IX+8)
        CP D
        JR NZ,kdir_1
        LD C,B
kdir_1  LD B,0
        CALL SETANIM
        JP WAITEND

OUT_EFS
        CALL ANIBANK
        LD A,(IX+10)
        LD HL,#4058
        CALL OUT_BAR
        LD A,(IX+11)
        LD HL,#405A
        CALL OUT_BAR
        LD A,(IX+12)
        LD HL,#405C
OUT_BAR RRA 
        RRA 
        RRA 
        AND 31
        PUSH AF
        CPL 
        AND 31
        JR Z,obar_2
        LD B,A
obar_1  LD (HL),#44
        CALL NEXT_HL
        DJNZ obar_1
obar_2  POP AF
        JR Z,obar_E
        LD B,A
obar_3  LD A,H
        RRA 
        LD A,#78
        JR C,obar_4
        LD A,#74
obar_4  LD (HL),A
        CALL NEXT_HL
        DJNZ obar_3
obar_E  LD (HL),#38
        RET 

NEXT_HL INC H
        LD A,H
        AND 7
        RET NZ
next_l  LD A,L
        ADD A,32
        LD L,A
        RET C
        LD A,H
        SUB 8
        LD H,A
        RET 
text
        CALL txt_E
        LD DE,#2012
        LD (PRN_POS),DE
txt_1   LD A,(HL)
        AND A
        JR Z,txt_E
        INC HL
        CP 32
        JR C,txt_C
        CALL PRINT
        JR txt_1
txt_C   PUSH HL
        LD HL,TxtComs
        LD C,A
        LD B,0
        ADD HL,BC
        ADD HL,BC
        LD A,(HL)
        INC HL
        LD H,(HL)
        LD L,A
        LD (txt_ADR+1),HL
        POP HL
txt_ADR CALL skip
        JR txt_1
txt_E
        RET 

TxtComs DW 0,T_01,skip,T_03
        DW T_04,T_05,skip,T_07
        DW T_08,T_09,T_10,T_11
        DW T_12,T_0D,T_14,T_15
        DW T_16,T_17,T_18,T_19
        DW T_20,T_21,T_22,T05_CLR
        DW T_24,T_25

T_25    LD A,(HL)
        INC HL
        CP #FF
        JP Z,MUZ_ON
        PUSH HL
        AND A
        JR Z,t25_0
        CALL SET_MUZ
        POP HL
        RET 
t25_0   CALL MUZ_OFF
        POP HL
        RET 

T_24    PUSH HL
        CALL FREEIT
        POP HL
        LD C,(HL)
        INC HL
        LD B,(HL)
        INC HL
        RET Z
        LD H,B
        LD L,C
        RET 

T_22    PUSH HL
        PUSH DE
        CALL WEND
        POP DE
        POP HL
        RET 

T_21    LD A,#37
        CALL T21poke
        CALL T_20
        LD A,#A7
T21poke LD (T20A),A
        LD (T20B),A
        LD (T20C),A
        RET 
T_20
        PUSH HL
        PUSH DE
T20A    AND A
        CALL NC,T20_NUM
        LDB (T20CPos),#44
        CALL T20_CRS
        LD DE,MGXnumz
t20_3   LD HL,Port_A
        CALL KEYS
        CP "Q"
        JR Z,t20_U
        CP "A"
        JR Z,t20_D
T20B    AND A
        JR C,t20_3A
        CP "O"
        JR Z,t20_M
        CP "P"
        JP Z,t20_P
        JR t20_3B
t20_3A  CP 32
        JR NZ,t20_3B
        CALL ORUCOST
        LD HL,(Money)
        AND A
        SBC HL,BC
        JR C,t20_3
        LD (Money),HL
        CALL ANIBANK
        LD A,(IX+11)
        ADD A,D
        JR NC,t20ax
        SBC A,A
t20ax   LD (IX+11),A
        LD A,(IX+12)
        ADD A,E
        JR NC,t20ay
        SBC A,A
t20ay   LD (IX+12),A
        CALL OUT_EFS
        CALL PRN_MON
        CALL ACTBANK
        CALL NOKEY
        JR t20_3
t20_3B  CP 13
        JR NZ,t20_3
        CALL T20_CRS
        CALL T05_CLR
        CALL T_NEW
        POP HL
        POP HL
        RET 
t20_U   LD A,(T20CPos)
        SUB #20
        CP #40
        JR C,t20_3
        DEC DE
t20u_1  PUSH AF
        CALL T20_CRS
        POP AF
        LD (T20CPos),A
        CALL T20_CRS
        CALL NOKEY
        JR t20_3
t20_D   LD A,(T20CPos)
        ADD A,#20
        CP #E0
        JP NC,t20_3
        INC DE
        JR t20u_1
t20_M   LD A,(DE)
        SUB 1
        JP C,t20_3
        LD (DE),A
        CALL GETCOST
        LD HL,(Money)
        ADD HL,BC
        LD (Money),HL
t20m_1  PUSH DE
        CALL PRN_MON
        CALL T20_NUM
        POP DE
        CALL NOKEY
        JP t20_3
t20_P   CALL GETCOST
        LD HL,(Money)
        AND A
        SBC HL,BC
        JP C,t20_3
        LD A,(DE)
        CP 99
        JP NC,t20_3
        LD (Money),HL
        LD A,(DE)
        INC A
        LD (DE),A
        JR t20m_1
T20_NUM LD HL,MGXnumz
        LD DE,#A012
        LD B,5
t20_1   CALL outnmz
        INC E
        INC HL
        DJNZ t20_1
        RET 
T20_CRS LD HL,#5A42
T20CPos EQU $-2
        LD B,18
t20c_1  LD A,(HL)
        XOR #2D
        LD (HL),A
        INC L
        DJNZ t20c_1
        RET 

GETCOST LD HL,Kozt1
        JR getco
ORUCOST LD HL,Kozt2
getco   LD A,(T20CPos)
        AND #E0
        SUB #40
        RRA 
        RRA 
        RRA 
        LD C,A
        LD B,0
        ADD HL,BC
        LD C,(HL)
        INC HL
        LD B,(HL)
T20C    AND A
        RET NC
        INC HL
        LD E,(HL)
        INC HL
        LD D,(HL)
        RET 

Kozt1   DW 700,0,500,0,200,0,300,0,400,0
Kozt2   DW 750,#3200,300,#1400,150,#0A00
        DW 200,#28,100,#14

T_19    LD A,(HL)
        INC HL
        LD B,(HL)
        INC HL
        LD C,(HL)
        INC HL
        PUSH HL
        PUSH DE
        LD D,B
        LD E,C
        CALL POLOZH
        CALL ACTBANK
        POP DE
        POP HL
        RET 

T_18    PUSH HL
        PUSH DE
        CALL ANIBANK
        LD (IX+10),#FF
        CALL OUT_EFS
        CALL ACTBANK
        POP DE
        POP HL
        RET 

T_17    PUSH HL
        CALL DRAWMAP
        CALL ANI_ON
        CALL T05_CLR
        CALL ACTBANK
        POP HL
        RET 

T_16    LD B,(HL)
        INC HL
t16_1   HALT 
        DJNZ t16_1
        RET 

T_15    PUSH HL
        CALL ANI_OFF
        CALL DARKER
        CALL T05_CLR
        POP HL
        RET 

T_14    PUSH HL
        LD HL,(yes_AD)
        LD D,(HL)
        INC HL
        LD (PRN_POS),DE
        CALL txt_1
        LD HL,(no_AD)
        INC E
        LD D,(HL)
        INC HL
        LD (PRN_POS),DE
        CALL txt_1
        LD A,E
        SUB #11
        ADD A,A
        ADD A,A
        ADD A,A
        ADD A,A
        ADD A,A
        ADD A,#10
        LD (T14_CRS+1),A
        ADD A,32
        LD (T14_alt+1),A
T14_0   LD A,#37
T14_A   LD (T14_pos),A
        CALL T14_CRS
        CALL NOKEY
T14_C   LD HL,Port_A
        CALL KEYS
        CP "Q"
        JR Z,T14_1
        CP "A"
        JR Z,T14_2
        CP " "
        JR NZ,T14_C
        CALL T05_CLR
        POP HL
        LD E,(HL)
        INC HL
        LD D,(HL)
        INC HL
        LD A,(HL)
        INC HL
        LD H,(HL)
        LD L,A
        LD A,(T14_pos)
        CP #37
        JP NZ,T_NEW
        EX DE,HL
        JP T_NEW
T14_2   LD A,(T14_pos)
        CP #37
        JR NZ,T14_C
        CALL T14_CRS
        LD A,#A7
        JR T14_A
T14_1   LD A,(T14_pos)
        CP #37
        JR Z,T14_C
        CALL T14_CRS
        JR T14_0
T14_CRS LD HL,#50B0
T14_pos SCF 
        JR C,T14P_1
T14_alt LD L,#D0
T14P_1  LD A,(HL)
        CPL 
        LD (HL),A
        INC L
        LD A,(HL)
        CPL 
        LD (HL),A
        INC L
        LD A,(HL)
        CPL 
        LD (HL),A
        DEC L
        DEC L
        INC H
        LD A,H
        AND 7
        JR NZ,T14P_1
        RET 

T_12    LD C,(HL)
        LD B,0
        INC HL
        INC HL
        INC HL
        PUSH HL
        LD HL,(Money)
        AND A
        SBC HL,BC
        JR NC,t11_1
        POP HL
        DEC HL
        LD A,(HL)
        DEC HL
        LD L,(HL)
        LD H,A
        RET 

T_11    LD C,(HL)
        LD B,0
        INC HL
        PUSH HL
        LD HL,(Money)
        ADD HL,BC
t11_1   LD (Money),HL
        PUSH DE
        CALL PRN_MON
        POP DE
        POP HL
        RET 

T_10    LD B,(HL)
        INC HL
        LD C,(HL)
        INC HL
        PUSH HL
        PUSH DE
        CALL SETANIM
        CALL ACTBANK
        POP DE
        POP HL
        RET 

T_09    LD C,(HL)
        INC HL
getitem PUSH HL
        CALL FREEIT
        JP NZ,ERROR
        LD (HL),C
        PUSH DE
        CALL DRITEMS
        CALL ACTBANK
        POP DE
        POP HL
        RET 
FREEIT  LD HL,Items
        LD A,(HL)
        INC A
        RET Z
        INC HL
        LD A,(HL)
        INC A
        RET Z
        INC HL
        LD A,(HL)
        INC A
        RET 

T_08    LD A,(HL)
        INC HL
delitem PUSH HL
        LD HL,Items
        CP (HL)
        JR Z,t08_A
        INC HL
        CP (HL)
        JR Z,t08_A
        INC HL
        CP (HL)
        JP NZ,ERROR
t08_A   LD (HL),255
        PUSH DE
        CALL DRITEMS
        CALL ACTBANK
        POP DE
        POP HL
        RET 

T_01    LD A,(HL)
        INC HL
setbit  PUSH HL
        CALL BITADDR
        LD A,(HL)
        OR C
        LD (HL),A
        CALL ANIBANK
        LD A,(IX+11)
        ADD A,1
        SBC A,0
        ADD A,1
        SBC A,0
        LD (IX+11),A
        LD A,(IX+12)
        ADD A,1
        SBC A,0
        LD (IX+12),A
        PUSH DE
        CALL OUT_EFS
        CALL ACTBANK
        POP DE
        POP HL
        RET 

T_03    LD A,(HL)
        INC HL
        PUSH HL
        CALL BITADDR
        LD A,(HL)
        JR t04_1

T_04    LD A,(HL)
        INC HL
        PUSH HL
        CALL BITADDR
        LD A,(HL)
        CPL 
t04_1   AND C
        POP HL
        LD C,(HL)
        INC HL
        LD B,(HL)
        INC HL
        RET Z
        LD H,B
        LD L,C
        RET 

T05_CLR PUSH HL
        JR t01_Z

T_05    CALL NOKEY
        PUSH HL
        CALL WAITDWN
t01_Z   CALL NOKEY
        LD HL,#5041
t01_0   LD B,5
t01_1   LD C,30
        LD A,L
t01_2   LD (HL),0
        INC L
        DEC C
        JR NZ,t01_2
        ADD A,32
        LD L,A
        DJNZ t01_1
        LD L,#41
        INC H
        LD A,H
        CP #58
        JR C,t01_0
        POP HL
T_NEW   LD DE,#2011
T_0D    INC E
        LD (PRN_POS),DE
        RET 
        
        display "T07 = ",$
T_07
        LD A,(HL)
        INC HL
        PUSH DE
        PUSH HL
CurMuz  LD B,0
        PUSH BC
        PUSH AF
        LD A,4
        CALL SET_MUZ
        POP AF
        CALL FIGHT
        PUSH AF
        CALL OUT_EFS
        CALL ACTBANK
        CALL T05_CLR
        POP AF
        POP BC
        POP HL
        POP DE
        JP NC,GAMOVER
        PUSH HL
        PUSH DE
        PUSH AF
        LD A,B
        CALL SET_MUZ
        POP AF
        POP DE
        POP HL
T07_WIN INC HL
        INC HL
        JR NZ,T07_RUN
        LD A,(HL)
        INC HL
        LD H,(HL)
        LD L,A
        RET 
T07_RUN INC HL
        INC HL
        RET 

PRINT   PUSH BC
        PUSH DE
        PUSH HL
        LD L,A
        LD H,0
        LD BC,FONT
        ADD HL,BC
        LD BC,0
PRN_POS EQU $-2
        LD A,B
        AND 7
        LD (prn_sm+1),A
        LD DE,Masks
        ADD A,A
        ADD A,E
        LD E,A
        ADC A,D
        SUB E
        LD D,A
        LDB (LMask+1),(DE)
        INC DE
        LDB (RMask+1),(DE)
        LD A,B
        RRA 
        RRA 
        RRA 
        AND 31
        LD B,A
        LD A,C
        RRCA 
        RRCA 
        RRCA 
        AND #E0
        OR B
        LD E,A
        LD A,C
        AND #18
        OR #40
        LD D,A
        LD A,7
prn_1   EXA 
        LD B,(HL)
        LD C,0
prn_sm  LD A,0
        AND A
        JR Z,prn_3
prn_2   SRL B
        RR C
        DEC A
        JR NZ,prn_2
prn_3   LD A,(DE)
LMask   AND 0
        OR B
        LD (DE),A
        INC E
        LD A,(DE)
RMask   AND 0
        OR C
        LD (DE),A
        DEC E
        INC D
        INC H
        EXA 
        DEC A
        JR NZ,prn_1
        LD A,(PRN_POS+1)
        ADD A,5
        LD (PRN_POS+1),A
        POP HL
        POP DE
        POP BC
        RET 

Masks   DB #07,#FF,#83,#FF,#C1,#FF,#E0,#FF
        DB #F0,#7F,#F8,#3F,#FC,#1F,#FE,#0F

testbit PUSH HL
        CALL BITADDR
        LD A,(HL)
        AND C
        POP HL
        RET 

BITADDR LD C,A
        LD HL,Bits
        RRA 
        RRA 
        RRA 
        AND 31
        ADD A,L
        LD L,A
        JR NC,$+3
        INC H
        LD A,C
        AND 7
        LD C,#80
        RET Z
badr_1  SRL C
        DEC A
        JR NZ,badr_1
        RET 

PRN_MON LD HL,#4039
        EXX 
        LD A,#37
        LD (zeroz),A
        LD DE,#C801
        LD HL,(Money)
        LD BC,1000
        CALL RAZR
        LD BC,100
        CALL RAZR
        LD BC,10
        CALL RAZR
        LD A,L
        ADD A,"0"
        LD (PRN_POS),DE
        JP PRINT

RAZR    LD (PRN_POS),DE
        EXX 
        LD B,8
raz_0   LD (HL),0
        INC H
        DJNZ raz_0
        LD H,#40
        INC L
        EXX 
        LD A,"0"-1
        AND A
raz_1   INC A
        SBC HL,BC
        JR NC,raz_1
        ADD HL,BC
zeroz   SCF 
        JR NC,raz_NZC
        CP "0"
        JR NZ,raz_NZC
        LD A," "
        CALL PRINT
        JR raz_NZE
raz_NZC CALL PRINT
        LD A,#A7
        LD (zeroz),A
raz_NZE LD A,D
        ADD A,8
        LD D,A
        RET 

HOT_K   PUSH BC
        XOR A
hk_1    PUSH AF
        LD (ACrsPos),A
        CALL ACTCRS0
        POP AF
        INC A
        CP 5
        JR C,hk_1
        LD HL,act_ico
        LD DE,#4033
        LD B,15
        CALL SPRITE
        POP BC
        LD A,C
        SUB 48
        LD (ACrsPos),A
        LD C,32
        JR kk_Z
KEY_FR
        LD HL,#5813
        LD DE,32
        EXX 
        LD B,16
        LD HL,dwn_ico
kfr_1   PUSH BC
        PUSH HL
        LD DE,#4033
        LD A,17
        SUB B
        CP 15
        JR C,kfr_2
        LD A,15
kfr_2   LD B,A
        HALT 
        HALT 
        CALL SPRITE
        EXX 
        LD (HL),1
        INC L
        LD (HL),1
        INC L
        LD (HL),1
        ADD HL,DE
        LD (HL),7
        DEC L
        LD (HL),7
        DEC L
        LD (HL),7
        EXX 
        POP HL
        LD BC,-24
        ADD HL,BC
        POP BC
        PUSH BC
        LD A,B
        SUB 4
        JR C,kfr_3
        INC A
        LD B,A
        CALL PUSTO

kfr_3   POP BC
        DJNZ kfr_1

kfr_A1  CALL ACTCRS1
kfr_A2  LD HL,Port_A
        CALL KEYS
        LD C,A
kk_Z    LD HL,AKeyTab
kfr_A3  LD A,(HL)
        AND A
        JR Z,kfr_A2
        INC HL
        CP C
        JR Z,kfr_A4
        INC HL
        INC HL
        JR kfr_A3
kfr_A4  LD A,(HL)
        INC HL
        LD H,(HL)
        LD L,A
        CALL CALL_HL
        JR NC,kfr_A2
        CALL ACTCRS0

kfr_END LD HL,#5A33
        LD DE,-32
        EXX 
        LD B,16
        LD HL,act_ico
kfr_E1  PUSH BC
        PUSH HL
        HALT 
        HALT 
        LD DE,#4033
        LD A,B
        CP 15
        JR C,kfr_E2
        LD B,15
kfr_E2  CALL SPRITE
        EXX 
        LD (HL),1
        INC L
        LD (HL),1
        INC L
        LD (HL),1
        ADD HL,DE
        LD (HL),7
        DEC L
        LD (HL),7
        DEC L
        LD (HL),7
        EXX 
        POP HL
        LD BC,24
        ADD HL,BC
        POP BC
        PUSH BC
        LD A,16
        SUB B
        LD B,A
        CALL NZ,PUSTO
        POP BC
        DJNZ kfr_E1
        RET 

AKeyTab DBW "Q",ACRS_UP
        DBW "A",ACRS_DN
        DBW "O",ICRS_LF
        DBW "P",ICRS_RG
        DBW " ",ACRS_GO
        DBW "1",HK
        DBW "2",HK
        DBW "3",HK
        DBW "4",HK
        DBW 13,BACK
        DB 0

HK      PUSH BC
        CALL ACTCRS0
        POP BC
        LD A,C
        SUB 48
        LD (ACrsPos),A
ACRS_GO LD C,4
        CALL ACTCRSC
        CALL NOKEY
        LD A,(ACrsPos)
        LD L,A
        LD H,0
        LD DE,ActAdrz
        ADD HL,HL
        ADD HL,DE
        LD A,(HL)
        INC HL
        LD H,(HL)
        LD L,A
        CALL CALL_HL
        EXA 
        CALL ACTCRS1
        EXA 
        RET 

ACRS_UP LD A,(ACrsPos)
        ADD A,255
        RET NC
acru_1  PUSH AF
        CALL ACTCRS0
        POP AF
        LD (ACrsPos),A
        CALL ACTCRS1
        CALL NOKEY
        AND A
        RET 

ACRS_DN LD A,(ACrsPos)
        INC A
        CP 5
        JR C,acru_1
        RET 

ACTCRS0 LD C,1
        JR ACTCRSC
ACTCRS1 LD C,7
ACTCRSC LD A,(ACrsPos)
        LD HL,#5833
        LD DE,96
        CALL ADDING
        LD DE,30
        LD B,3
acrs_1  LD (HL),C
        INC L
        LD (HL),C
        INC L
        LD (HL),C
        ADD HL,DE
        DJNZ acrs_1
        RET 

ACrsPos DB 0

ActAdrz DW BACK,TAKE,USE,TALK,MAGIC

BACK    SCF 
        RET 
TAKE
        CALL AHEAD
        EXA 
        LD A,D
        CP B
        JP NZ,ACTWAIT
        EXA 
        CP 255
        JP Z,GIVE
        CP 254
        JP Z,PICK
        CP NEP_nr
        JP NC,ACTWAIT
DROP
        CALL CURITEM
        CP 255
        JP Z,ACTWAIT
        CALL DROPPER
        CALL C,POLOZH
        LD (HL),255
        CALL DRITEMS
        SCF 
        RET 

POLOZH  PUSH HL
        PUSH DE
        CALL FINDITM
        POP BC
        PUSH HL
        LD D,254
        CALL SETFMAP
        POP HL
        INC HL
        LD (HL),B
        INC HL
        LD (HL),C
        INC HL
        LD (HL),E
        INC HL
        LD A,(HL)
        INC HL
        LD H,(HL)
        LD L,A
        LD A,(CurMap)
        CP B
        JR NZ,nodrw
        PUSH HL
        LD E,C
        LD B,0
        LD HL,SAdrTab
        ADD HL,BC
        ADD HL,BC
        LD A,(HL)
        INC HL
        LD H,(HL)
        LD L,A
        POP BC
        CALL GFXBANK
        PUSH HL
        LD HL,(ItemSee)
        ADD HL,BC
        LD B,H
        LD C,L
        POP HL
        CALL DRWBLOK
        CALL ANIBANK
nodrw   POP HL
        RET 

PICK    LD A,(Items)
        INC A
        JR Z,pick_Y
        LD A,(Items+1)
        INC A
        JR Z,pick_Y
        LD A,(Items+2)
        INC A
        JP NZ,ACTWAIT
pick_Y  LD A,L
        LD C,E
        PUSH AF
        PUSH BC
        CALL FINDITM
        POP BC
        INC HL
        LD (HL),255
        INC HL
        INC HL
        LD D,(HL)
        CALL SETFMAP
        LD D,0
        LD E,C
        LD HL,SAdrTab
        ADD HL,DE
        ADD HL,DE
        LD C,(HL)
        INC HL
        LD B,(HL)
        LD L,E
        LD H,0
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        LD DE,Map
        ADD HL,DE
        LD D,B
        LD E,C
        CALL OUTELEM
        LD HL,Items
        LD A,(HL)
        INC A
        JR Z,pick_1
        INC HL
        LD A,(HL)
        INC A
        JR Z,pick_1
        INC HL
pick_1  POP AF
        LD (HL),A
        CALL DRITEMS
        SCF 
        RET 

GIVE
        LD D,H
        CALL CURITEM
        LD E,A
        CALL ACTBANK
        LD HL,(TFrTAdr)
giv_01  LD A,(HL)
        AND A
        JR Z,giver
        INC HL
        CP D
        JR Z,giv_02
        INC HL
        INC HL
        JR giv_01

giver   LD HL,(GivTAdr)
give_1  LD A,(HL)
        CP 255
        JP Z,ACTWAIT
        CP E
        INC HL
        JR NZ,give_2
        LD A,(HL)
        CP D
        JR NZ,give_2
        INC HL
giv_02  LD A,(HL)
        INC HL
        LD H,(HL)
        LD L,A
        JP (HL)
give_2  INC HL
        INC HL
        INC HL
        JR give_1
USE
        CALL AHEAD
;       LD A,B
;       CP D
;       JP NZ,ACTWAIT
        LD D,H
        INC H
        JP Z,uiop_ON
        CALL ACTBANK

        CALL CURITEM
        LD E,A
        LD HL,(UIOPtad)
uiop_1  LD A,(HL)
        CP 255
        JP Z,ACTWAIT
        CP D
        INC HL
        JR NZ,uiop_2
        LD A,(HL)
        CP #FF
        JR Z,uiop_Y
        CP E
        JR NZ,uiop_2
uiop_Y  INC HL
        LD A,(HL)
        INC HL
        LD H,(HL)
        LD L,A
        JP (HL)
uiop_2  INC HL
        INC HL
        INC HL
        JR uiop_1
uiop_ON CALL ACTBANK
        CALL CURITEM
        LD E,A
        LD HL,(UsePtad)
uion_1  LD A,(HL)
        CP 255
        JP Z,ACTWAIT
        CP E
        JR NZ,ua
        INC HL
        LD A,(HL)
        INC HL
        CP 255
        JR Z,uiop_Y
        CP B
        JR NZ,uc
        LD A,(HL)
        CP C
        JR NZ,uc
        JR uiop_Y
ua      INC HL
        INC HL
uc      INC HL
        INC HL
        INC HL
        JR uion_1

TALK
        CALL AHEAD
        CALL ACTBANK
        LD C,H
        INC A
        JR Z,tlk_Y
ACTWAIT LD B,25
tlk_ER  HALT 
        DJNZ tlk_ER
        AND A
        RET 
tlk_Y   LD HL,(TlkTAdr)
tlk_1   LD A,(HL)
        AND A
        JR Z,ACTWAIT
        INC HL
        CP C
        JR Z,tlk_2
        INC HL
        INC HL
        JR tlk_1
tlk_2   LD A,(HL)
        INC HL
        LD H,(HL)
        LD L,A
        JP (HL)
MAGIC
        CALL AHEAD
        LD D,H
        INC H
        JP Z,ACTWAIT
        CALL ACTBANK
        LD HL,(BitTAdr)
        JP uiop_1

ICRS_LF LD A,(ItemPos)
        ADD A,255
        JR C,icrr_1
        RET 

ICRS_RG LD A,(ItemPos)
        CP 2
        RET Z
        INC A
icrr_1  PUSH AF
        CALL ITMRAMK
        POP AF
        LD (ItemPos),A
        CALL ITMRAMK
        JP NOKEY
CURITEM
        LD A,(ItemPos)
        LD HL,Items
        ADD A,L
        LD L,A
        JR NC,$+3
        INC H
        LD A,(HL)
        RET 

ItemPos DB 0

ITMRAMK
        LD A,(ItemPos)
        LD HL,#4816
        AND A
        JR Z,iram_D
        LD L,#19
        DEC A
        JR Z,iram_D
        LD L,#1C
iram_D  LD DE,ItemRmk
        LD B,8
        PUSH HL
        CALL iram_D3
        POP HL
        LD A,L
        ADD A,32
        LD L,A
        LD B,2
iram_1  LD A,(DE)
        XOR (HL)
        LD (HL),A
        INC DE
        INC L
        INC L
        INC L
        LD A,(DE)
        XOR (HL)
        LD (HL),A
        INC DE
        DEC L
        DEC L
        DEC L
        INC H
        LD A,H
        AND 7
        JR NZ,iram_1
        LD A,H
        SUB 8
        LD H,A
        LD A,L
        ADD A,32
        LD L,A
        DJNZ iram_1
iram_D3 LD B,8
iram_2  LD A,(DE)
        XOR (HL)
        LD (HL),A
        INC L
        INC DE
        LD A,(DE)
        XOR (HL)
        LD (HL),A
        INC L
        INC DE
        LD A,(DE)
        XOR (HL)
        LD (HL),A
        INC L
        INC DE
        LD A,(DE)
        XOR (HL)
        LD (HL),A
        INC DE
        DEC L
        DEC L
        DEC L
        INC H
        DJNZ iram_2
        JP ITMNAME

DRITEMS
        CALL ITMNAME
        LD A,(Items)
        LD DE,#4837
        CALL OUITEM
        LD A,(Items+1)
        LD DE,#483A
        CALL OUITEM
        LD A,(Items+2)
        LD DE,#483D
OUITEM
        CP 255
        LD HL,EmpItem
        JR Z,oit_0
        PUSH DE
        CALL FINDITM
        POP DE
        JP C,ERROR
        LD BC,6
        ADD HL,BC
        LD A,(HL)
        INC HL
        LD H,(HL)
        LD L,A
        CALL GFXBANK
        LD BC,(ItemSee)
        ADD HL,BC
oit_0   LD BC,#02FF
        PUSH DE
oit_1   LDI 
        LDI 
        DEC E
        DEC E
        INC D
        LD A,D
        AND 7
        JR NZ,oit_1
        LD A,E
        ADD A,32
        LD E,A
        JR C,oit_2
        LD A,D
        SUB 8
        LD D,A
oit_2   DJNZ oit_1
        POP DE
        LD A,D
        RRA 
        RRA 
        RRA 
        AND 3
        OR #58
        LD D,A
        LDI 
        LDI 
        LD A,E
        ADD A,30
        LD E,A
        JR NC,oit_3
        INC D
oit_3   LDI 
        LDI 
        JP ANIBANK

finditm LD C,A
        CALL ANIBANK
        LD HL,(IDSCAdr)
        LD DE,8
fite_1  LD A,(HL)
        CP 255
        SCF 
        RET Z
        CP C
        RET Z
        ADD HL,DE
        JR fite_1

KEYS    LD A,(HL)
        AND A
        RET Z
        IN A,(254)
        INC HL
        AND (HL)
        INC HL
        LD A,(HL)
        RET Z
        INC HL
        JR KEYS

CALL_HL JP (HL)

NOKEY   XOR A
        IN A,(254)
        CPL 
        AND 31
        JR NZ,NOKEY
        RET 

WAITKEY XOR A
        IN A,(254)
        CPL 
        AND 31
        JR Z,WAITKEY
        RET 

WAITDWN XOR A
        IN A,(254)
        CPL 
        AND 31
        JR NZ,wd_EX
        HALT 
wd_CNT  LD A,1
        DEC A
        LD (wd_CNT+1),A
        JR NZ,WAITDWN
        LD A,5
        LD (wd_CNT+1),A
wd_SPR  LD A,0
        INC A
        LD (wd_SPR+1),A
        AND 3
        LD HL,WSpr
        JR Z,wd_1
        DEC A
        LD HL,WSpr+8
        JR Z,wd_1
        DEC A
        LD HL,WSpr+16
        JR Z,wd_1
        LD HL,WSpr+24
wd_1    LD BC,#50DE
wd_2    LD A,(HL)
        LD (BC),A
        INC HL
        INC B
        LD A,B
        AND 7
        JR NZ,wd_2
        JR WAITDWN
wd_EX   LD HL,#50DE
        LD B,7
wdex_1  LD (HL),0
        INC H
        DJNZ wdex_1
        RET 

WSpr    INCBIN "pagez 4.bin"

        INCLUDE "animate.asm"

wend    CALL WAITEND
        JP ACTBANK

WAITEND CALL ANIBANK
wend_1  HALT 
        LD A,(IX+9)
        INC A
        JP Z,WRKPAGE
        BIT 0,(IX+1)
        JR Z,wend_1
        CALL ANI_OFF
        BIT 1,(IX+1)
        CALL NZ,DARKER
        LD A,(IX+6)
        LD (CurMap),A
        CALL DRAWMAP
        CALL ANIBANK
        RES 0,(IX+1)
        BIT 1,(IX+1)
        RES 1,(IX+1)
        EXA 
        CALL ANI_ON
        EXA 
        JR Z,wend_1
        LD (IX+9),#FF
        RET 

DARKER  LD DE,TxturZ
        LD B,6
drk_0   PUSH BC
        LD HL,#4021
        LD B,16
drk_1   LD C,16
drk_2   PUSH DE
drk_3   LD A,(DE)
        AND (HL)
        LD (HL),A
        INC H
        INC DE
        LD A,H
        AND 7
        JR NZ,drk_3
        LD A,H
        SUB 8
        LD H,A
        POP DE
        INC L
        DEC C
        JR NZ,drk_2
        LD A,L
        ADD A,16
        LD L,A
        JR NC,drk_4
        LD A,H
        ADD A,8
        LD H,A
drk_4   DJNZ drk_1
        POP BC
        DUP 8
         INC DE
        EDUP 
        HALT 
        HALT 
        HALT 
        DJNZ drk_0
        RET 

TxturZ  DEFBLOCK 4,<#FF,#55>
        DEFBLOCK 4,<#AA,#55>
        DEFBLOCK 4,<#AA,#00>
        DEFBLOCK 2,<#AA,#00,#44,#00>
        DEFBLOCK 2,<#44,#00,#00,#00>
        DS 8

setanim CALL ANIBANK
        PUSH IX
        CALL FIND_B
        LD A,C
        CALL SET_ANI
        POP IX
        JP ACTBANK

SETSPRT CALL ANIBANK
        PUSH IX
        CALL FIND_B
        LD A,C
        CALL SET_SPR
        LD (IX+13),1
        POP IX
        JP WRKPAGE

SET_ANI LD C,A
        CP (IX+9)
        RET Z
        LD (IX+9),A
        LD L,(IX+4)
        LD H,(IX+5)
        LD B,0
        ADD HL,BC
        ADD HL,BC
        LD A,(HL)
        LD (IX+20),A
        LD (IX+22),A
        INC HL
        LD A,(HL)
        LD (IX+21),A
        LD (IX+23),A
        RET 

SET_SPR LD C,A
        LD A,(IX+8)
        CP C
        RET Z
        INC A
        JR Z,sspr_N
        LD A,(CurMap)
        CP (IX+6)
        JR NZ,sspr_N
        PUSH BC
        CALL GETSPRP
        POP BC
        LD A,D
        CP (IX+24)
        JR NZ,sspr_R
        LD A,E
        CP (IX+25)
        JR NZ,sspr_R
        LD A,L
        CP (IX+28)
        JR NZ,sspr_R
        LD A,H
        CP (IX+29)
        JR Z,sspr_N
sspr_R  PUSH BC
        LD L,(IX+28)
        LD H,(IX+29)
        CALL RESTFON
        POP BC
sspr_N  LD (IX+8),C
        CALL GETSPRP
        LD (IX+24),D
        LD (IX+25),E
        LD (IX+26),C
        LD (IX+27),B
        LD (IX+28),L
        LD (IX+29),H
        LD (IX+30),A
        EXA 
        LD (IX+31),A
DRWPERS LD A,(CurMap)
        CP (IX+6)
        RET NZ
        LD E,(IX+31)
        LD A,(IX+25)
dper_1  PUSH AF
        PUSH HL
        PUSH DE
        LD A,(IX+24)
dper_2  PUSH AF
        PUSH HL
        PUSH DE
        CALL DRWBLOK
        POP DE
        POP HL
        POP AF
        INC L
        INC L
        INC E
        DEC A
        JR NZ,dper_2
        POP DE
        POP HL
        LD A,E
        ADD A,8
        LD E,A
        LD A,L
        ADD A,64
        LD L,A
        JR NC,dper_3
        LD A,H
        ADD A,8
        LD H,A
dper_3  POP AF
        DEC A
        JR NZ,dper_1
        RET 

RESTFON PUSH HL
        LD L,(IX+31)
        LD H,0
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        LD BC,Map
        ADD HL,BC
        POP DE
        LD B,(IX+25)
ssr_0   LD C,(IX+24)
        PUSH DE
        PUSH HL
ssr_1   PUSH BC
        CALL OUTELEM
        POP BC
        INC E
        INC E
        DEC C
        JR NZ,ssr_1
        POP HL
        POP DE
        INC H
        LD A,E
        ADD A,64
        LD E,A
        JR NC,ssr_2
        LD A,D
        ADD A,8
        LD D,A
ssr_2   DJNZ ssr_0
        RET 

DRWBLOK PUSH HL                 ; in  E=delta
        LD L,E                  ;    BC=sprite adr (mask-byte)
        LD H,0                  ;    HL=screen adr
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        LD DE,Map
        ADD HL,DE
        EX DE,HL
        POP HL
        PUSH DE
        EXX 
        POP HL
        LD A,H
        ADD A,8
        LD H,A
        EXX 
        LD A,2
dblk_1  PUSH AF
dblk_1A LD A,2
dblk_2  PUSH AF
        LD A,(BC)
        EXX 
        CPL 
        AND (HL)
        LD E,A
        CPL 
        EXX 
        EX DE,HL
        AND (HL)
        EX DE,HL
        LD (HL),A
        INC BC
        LD A,(BC)
        EXX 
        AND E
        EXX 
        OR (HL)
        LD (HL),A
        INC L
        INC BC
        INC DE
        EXX 
        INC HL
        EXX 
        POP AF
        DEC A
        JR NZ,dblk_2
        DEC L
        DEC L
        INC H
        LD A,H
        AND 7
        JR NZ,dblk_1A
        LD A,L
        ADD A,32
        LD L,A
        JR C,dblk_3
        LD A,H
        SUB 8
        LD H,A
dblk_3  POP AF
        DEC A
        JR NZ,dblk_1
        RET 

GETSPRP LD L,(IX+2)
        LD H,(IX+3)
        LD B,0
        ADD HL,BC
        ADD HL,BC
        LD A,(HL)
        INC HL
        LD H,(HL)
        LD L,A
        PUSH HL
        INC HL
        INC HL
        INC HL
        INC HL
        LD A,(IX+7)
        BIT 0,(HL)
        JR Z,gspp_A
        DEC A
gspp_A  BIT 1,(HL)
        JR Z,gspp_B
        SUB 8
gspp_B  LD L,A
        EXA 
        LD H,0
        ADD HL,HL
        LD DE,SAdrTab
        ADD HL,DE
        LD A,(HL)
        INC HL
        LD H,(HL)
        LD L,A
        EX (SP),HL
        LD D,(HL)
        INC HL
        LD E,(HL)
        INC HL
        LD C,(HL)
        INC HL
        LD B,(HL)
        INC HL
        LD A,(HL)
        POP HL
        RET 

FIND_B  LD IX,(PDSCAdr)
        LD DE,32
finb_1  LD A,(IX)
        CP B
        RET Z
        INC A
        ADD IX,DE
        JR NZ,finb_1
error   POP HL
        SCF 
stack   LD SP,0
        RET 

;======================

DRAWMAP
        CALL DEL_ALL
        CALL MAPBANK

        LD A,(CurMap)
        LD L,A
        LD H,#FB
        LD A,(HL)
        CALL MAPCOL
        LD A,(CurMap)
        CALL GETMADR
        LD DE,Map
dmap_1  PUSH HL
        LD A,(HL)
        CP 64
        LD BC,Sprt_P
        JR C,dmap_NP
        SUB 64
        CP 32
        LD BC,Sprt_M
        JR C,dmap_M
        LD BC,Sprt_N
        SUB 32
dmap_NP LD L,A
        LD H,0
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        ADD HL,BC
        CALL DRWSPR
        LD HL,FFmask
        JR dmap_E
dmap_M  LD L,A
        LD H,0
        LD BC,Sprt_M
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        ADD HL,BC
        CALL DRWSPR
dmap_E  LD A,D
        PUSH AF
        ADD A,8
        LD D,A
        CALL DRWSPR
        POP AF
        LD D,A
        POP HL
        INC HL
        LD A,E
        ADD A,32
        LD E,A
        JR NC,dmap_F
        INC D
dmap_F  LD A,D
        CP high Map + 8
        JR C,dmap_1
        LD DE,#4021
        LD HL,Map
        LD B,8
dmap_D1 LD C,8
dmap_D2 PUSH BC
        CALL OUTELEM
        POP BC
        INC E
        INC E
        DEC C
        JR NZ,dmap_D2
        LD A,E
        ADD A,48
        LD E,A
        JR NC,dmap_D5
        LD A,D
        ADD A,8
        LD D,A
dmap_D5 DJNZ dmap_D1

        CALL SET_ALL
        JP DRW_ALL

MAPCOL  LD HL,#5821
        LD DE,16
        LD B,E
dmap_E1 LD C,E
dmap_E2 LD (HL),A
        INC L
        DEC C
        JR NZ,dmap_E2
        ADD HL,DE
        DJNZ dmap_E1
        RET 

OUTELEM PUSH DE         ; вывод элемента
        LD BC,#02FF     ; DE = scr.adr
dmap_D3 LDI             ; HL = spr.adr (2*2)
        LDI 
        DEC E
        DEC E
        INC D
        LD A,D
        AND 7
        JR NZ,dmap_D3
        LD A,E
        ADD A,32
        LD E,A
        JR C,dmap_D4
        LD A,D
        SUB 8
        LD D,A
dmap_D4 DJNZ dmap_D3
        POP DE
        RET 
GETMADR
        LD L,A
        LD H,0
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        ADD HL,HL
        LD A,H
        OR #C0
        LD H,A
        RET 

DRWSPR  PUSH DE
        LD BC,32
        LDIR 
        POP DE
        RET 

chanmap LD A,#37
        LD (chmap_E),A
chmap_1 LD A,(HL)
        LD B,A
        INC A
        JR Z,chmap_E
        LD A,(CurMap)
        CP B
        JR NZ,chmap_2
        LD A,#A7
        LD (chmap_E),A
chmap_2 INC HL
        LD C,(HL)
        INC HL
        LD D,(HL)
        INC HL
        PUSH HL
        CALL SETAMAP
        POP HL
        JR chmap_1
chmap_E SCF 
        CALL NC,DRAWMAP
        JP ACTBANK

;HRUST   INCBIN "dehrust.bin"
HRUST	include "dehrustIX.asm"

ADDING  INC A
add_0   DEC A
        RET Z
        ADD HL,DE
        JR add_0
;-------------
SPRITE  LD C,#FF
        LDI 
        LDI 
        LD A,(HL)
        LD (DE),A
        INC HL
        DEC E
        DEC E
        INC D
        LD A,D
        AND 7
        JR NZ,SPRITE
        LD A,E
        ADD A,32
        LD E,A
        JR C,spri_1
        LD A,D
        SUB 8
        LD D,A
spri_1  DJNZ SPRITE
        RET 

PUSTO   XOR A
        LD (DE),A
        INC E
        LD (DE),A
        INC E
        LD (DE),A
        DEC E
        DEC E
        INC D
        LD A,D
        AND 7
        JR NZ,PUSTO
        LD A,E
        ADD A,32
        LD E,A
        JR C,pust_1
        LD A,D
        SUB 8
        LD D,A
pust_1  DJNZ PUSTO
        RET 

freeitm LD A,255
ifitem  LD HL,Items
        CP (HL)
        RET Z
        INC HL
        CP (HL)
        RET Z
        INC HL
        CP (HL)
        RET 

        INCLUDE "fight3.asm"
;---------------
load_PG LD A,(CurPage)
        PUSH AF
        LD A,C
        CALL BANK
        PUSH HL
        DI 
        LD A,#3F
        LD I,A
        IM 1
        LD A,(muzflag)
        PUSH AF
        CALL MUZ_OFF
        EI 
        CALL LOAD
        DI 
        LD A,#70
        LD I,A
        IM 2
        POP AF
        LD (muzflag),A
        EI 
        POP HL
        LD D,H
        LD E,L
        CALL HRUST
        POP AF
        JP BANK

EmpItem DS 32
        DB 7,7,7,7
FFmask  DS 32,#FF
CurMap  DB 0

Items   DB 0,0,0
Money   DW 0

SAdrTab
AD0=#4021
        DUP 2
AD1=AD0
        DUP 4
        DUP 8
        DW AD1
AD1=AD1+2
        EDUP 
AD1=AD1+48
        EDUP 
AD0=#4821
        EDUP 

ItemRmk INCBIN "ItemRamk.bin"
FONT    INCBIN "vikfont.fnt",0,#700

act_ico INCBIN "3-16 ico.bin"
dwn_ico EQU act_ico+360

Bits    EQU #BF80
FREE    EQU $

        DISPLAY "N-Gine    (",aBgn,",",$-aBgn,"):",$
        savebin "obj/main.7171.7177.bin",aBgn,$-aBgn

        INCLUDE "act_ovl.asm"
        INCLUDE "ani_ovl.asm"

        SAVESNA "vq3.sna",START